#!/usr/bin/env python3
#
# mmgen = Multi-Mode GENerator, command-line Bitcoin cold storage solution
# Copyright (C)2013-2019 The MMGen Project <mmgen@tuta.io>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
mmgen.exception: Exception classes for the MMGen suite
"""

# 1: no hl, message only
class UserNonConfirmation(Exception):     mmcode = 1
class BadAgeFormat(Exception):            mmcode = 1
class BadFilename(Exception):             mmcode = 1

# 2: yellow hl, message only
class UnrecognizedTokenSymbol(Exception): mmcode = 2
class TokenNotInBlockchain(Exception):    mmcode = 2

# 3: yellow hl, 'MMGen Error' + exception + message
class RPCFailure(Exception):              mmcode = 3
class BadTxSizeEstimate(Exception):       mmcode = 3

# 4: red hl, 'MMGen Fatal Error' + exception + message
class BadMMGenTxID(Exception):            mmcode = 4
class IllegalWitnessFlagValue(Exception): mmcode = 4
class WitnessSizeMismatch(Exception):     mmcode = 4
class TxHexMismatch(Exception):           mmcode = 4
